with GNATCOM.Dispinterface;

package MSHTML.IHTMLCSSStyleDeclaration_Object is

   type IHTMLCSSStyleDeclaration_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   function Get_length
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   function Get_parentRule
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   function getPropertyValue
     (This             : IHTMLCSSStyleDeclaration_Type;
      bstrPropertyName : GNATCOM.Types.VARIANT;
      Free             : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function getPropertyPriority
     (This             : IHTMLCSSStyleDeclaration_Type;
      bstrPropertyName : GNATCOM.Types.VARIANT;
      Free             : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function removeProperty
     (This             : IHTMLCSSStyleDeclaration_Type;
      bstrPropertyName : GNATCOM.Types.VARIANT;
      Free             : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure setProperty
     (This                 : IHTMLCSSStyleDeclaration_Type;
      bstrPropertyName     : GNATCOM.Types.VARIANT;
      pvarPropertyValue    : GNATCOM.Types.VARIANT;
      pvarPropertyPriority : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free                 : Boolean := True);

   function item
     (This  : IHTMLCSSStyleDeclaration_Type;
      index : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure Put_fontFamily
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_fontFamily
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_fontStyle
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_fontStyle
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_fontVariant
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_fontVariant
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_fontWeight
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_fontWeight
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_fontSize
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_fontSize
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_font
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_font
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_color
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_color
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_background
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_background
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_backgroundColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_backgroundColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_backgroundImage
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_backgroundImage
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_backgroundRepeat
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_backgroundRepeat
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_backgroundAttachment
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_backgroundAttachment
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_backgroundPosition
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_backgroundPosition
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_backgroundPositionX
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_backgroundPositionX
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_backgroundPositionY
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_backgroundPositionY
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_wordSpacing
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_wordSpacing
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_letterSpacing
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_letterSpacing
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textDecoration
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textDecoration
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_verticalAlign
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_verticalAlign
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textTransform
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textTransform
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textAlign
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textAlign
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textIndent
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textIndent
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_lineHeight
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_lineHeight
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_marginTop
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_marginTop
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_marginRight
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_marginRight
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_marginBottom
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_marginBottom
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_marginLeft
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_marginLeft
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_margin
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_margin
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_paddingTop
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_paddingTop
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_paddingRight
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_paddingRight
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_paddingBottom
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_paddingBottom
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_paddingLeft
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_paddingLeft
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_padding
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_padding
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_border
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_border
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderTop
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderTop
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderRight
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderRight
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderBottom
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderBottom
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderLeft
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderLeft
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderTopColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderTopColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderRightColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderRightColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderBottomColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderBottomColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderLeftColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderLeftColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderWidth
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderWidth
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderTopWidth
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderTopWidth
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderRightWidth
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderRightWidth
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderBottomWidth
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderBottomWidth
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderLeftWidth
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderLeftWidth
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderStyle
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderStyle
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderTopStyle
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderTopStyle
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderRightStyle
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderRightStyle
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderBottomStyle
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderBottomStyle
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderLeftStyle
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderLeftStyle
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_width
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_width
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_height
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_height
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_styleFloat
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_styleFloat
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_clear
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_clear
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_display
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_display
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_visibility
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_visibility
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_listStyleType
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_listStyleType
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_listStylePosition
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_listStylePosition
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_listStyleImage
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_listStyleImage
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_listStyle
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_listStyle
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_whiteSpace
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_whiteSpace
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_top
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_top
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_left
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_left
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_zIndex
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_zIndex
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_overflow
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_overflow
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_pageBreakBefore
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_pageBreakBefore
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_pageBreakAfter
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_pageBreakAfter
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_cssText
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_cssText
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_cursor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_cursor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_clip
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_clip
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_filter
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_filter
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_tableLayout
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_tableLayout
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderCollapse
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderCollapse
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_direction
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_direction
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_behavior
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_behavior
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_position
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_position
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_unicodeBidi
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_unicodeBidi
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_bottom
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_bottom
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_right
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_right
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_imeMode
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_imeMode
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_rubyAlign
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_rubyAlign
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_rubyPosition
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_rubyPosition
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_rubyOverhang
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_rubyOverhang
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_layoutGridChar
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_layoutGridChar
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_layoutGridLine
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_layoutGridLine
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_layoutGridMode
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_layoutGridMode
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_layoutGridType
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_layoutGridType
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_layoutGrid
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_layoutGrid
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textAutospace
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textAutospace
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_wordBreak
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_wordBreak
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_lineBreak
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_lineBreak
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textJustify
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textJustify
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textJustifyTrim
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textJustifyTrim
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textKashida
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textKashida
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_overflowX
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_overflowX
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_overflowY
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_overflowY
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_accelerator
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_accelerator
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_layoutFlow
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_layoutFlow
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_zoom
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_zoom
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_wordWrap
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_wordWrap
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textUnderlinePosition
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textUnderlinePosition
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_scrollbarBaseColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_scrollbarBaseColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_scrollbarFaceColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_scrollbarFaceColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_scrollbar3dLightColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_scrollbar3dLightColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_scrollbarShadowColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_scrollbarShadowColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_scrollbarHighlightColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_scrollbarHighlightColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_scrollbarDarkShadowColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_scrollbarDarkShadowColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_scrollbarArrowColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_scrollbarArrowColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_scrollbarTrackColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_scrollbarTrackColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_writingMode
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_writingMode
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textAlignLast
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textAlignLast
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textKashidaSpace
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textKashidaSpace
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textOverflow
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textOverflow
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_minHeight
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_minHeight
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_msInterpolationMode
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_msInterpolationMode
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_maxHeight
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_maxHeight
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_minWidth
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_minWidth
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_maxWidth
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_maxWidth
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_content
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_content
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_captionSide
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_captionSide
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_counterIncrement
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_counterIncrement
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_counterReset
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_counterReset
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_outline
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_outline
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_outlineWidth
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_outlineWidth
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_outlineStyle
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_outlineStyle
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_outlineColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_outlineColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_boxSizing
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_boxSizing
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderSpacing
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderSpacing
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_orphans
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_orphans
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_widows
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_widows
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_pageBreakInside
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_pageBreakInside
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_emptyCells
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_emptyCells
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_msBlockProgression
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_msBlockProgression
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_quotes
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_quotes
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_alignmentBaseline
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_alignmentBaseline
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_baselineShift
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_baselineShift
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_dominantBaseline
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_dominantBaseline
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_fontSizeAdjust
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_fontSizeAdjust
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_fontStretch
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_fontStretch
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_opacity
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_opacity
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_clipPath
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_clipPath
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_clipRule
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_clipRule
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_fill
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_fill
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_fillOpacity
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_fillOpacity
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_fillRule
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_fillRule
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_kerning
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_kerning
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_marker
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_marker
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_markerEnd
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_markerEnd
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_markerMid
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_markerMid
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_markerStart
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_markerStart
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_mask
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_mask
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_pointerEvents
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_pointerEvents
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_stopColor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_stopColor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_stopOpacity
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_stopOpacity
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_stroke
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_stroke
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_strokeDasharray
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_strokeDasharray
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_strokeDashoffset
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_strokeDashoffset
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_strokeLinecap
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_strokeLinecap
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_strokeLinejoin
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_strokeLinejoin
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_strokeMiterlimit
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_strokeMiterlimit
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_strokeOpacity
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_strokeOpacity
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_strokeWidth
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_strokeWidth
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textAnchor
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textAnchor
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_glyphOrientationHorizontal
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_glyphOrientationHorizontal
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_glyphOrientationVertical
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_glyphOrientationVertical
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderRadius
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderRadius
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderTopLeftRadius
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderTopLeftRadius
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderTopRightRadius
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderTopRightRadius
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderBottomRightRadius
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderBottomRightRadius
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_borderBottomLeftRadius
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_borderBottomLeftRadius
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_clipTop
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_clipTop
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_clipRight
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_clipRight
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   function Get_clipBottom
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_clipLeft
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_clipLeft
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_cssFloat
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_cssFloat
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_backgroundClip
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_backgroundClip
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_backgroundOrigin
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_backgroundOrigin
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_backgroundSize
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_backgroundSize
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_boxShadow
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_boxShadow
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_msTransform
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_msTransform
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_msTransformOrigin
     (This : IHTMLCSSStyleDeclaration_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_msTransformOrigin
     (This : IHTMLCSSStyleDeclaration_Type)
     return GNATCOM.Types.VARIANT;

end MSHTML.IHTMLCSSStyleDeclaration_Object;

